#!/usr/bin/env python

from GPGUtils import GPG, as_string
from email import message_from_file
from email.mime.message import MIMEMessage
from subprocess import Popen, PIPE
import sys

# Postfix exit codes.

EX_TEMPFAIL     = 75

try:
    # Obtain an identity.

    gpg = GPG()
    identity = sys.argv[1]
    recipients = sys.argv[2:]
    original = message_from_file(sys.stdin)

    # Wrap the message in its own container.

    msg = MIMEMessage(original)

    # Sign the message.

    msg = gpg.signMessage(msg, identity)
    msg["From"] = identity
    msg["To"] = original["To"]
    msg["Subject"] = original["Subject"]

    # Submit to Postfix without causing routing loops.

    sendmail = Popen(["/usr/sbin/sendmail", "-G", "-i"] + recipients, shell=False, stdin=PIPE, stdout=PIPE, stderr=PIPE)
    sendmail.stdin.write(as_string(msg))
    out, err = sendmail.communicate()
    retcode = sendmail.wait()

    sys.exit(retcode)

except Exception, exc:
    if "-v" in sys.argv[1:]:
        raise
    type, value, tb = sys.exc_info()
    print >>sys.stderr, "Exception %s at %d" % (exc, tb.tb_lineno)
    #import traceback
    #traceback.print_exc(file=open("/tmp/mail.log", "a"))
    sys.exit(EX_TEMPFAIL)

sys.exit(0)

# vim: tabstop=4 expandtab shiftwidth=4
